import { PageVisibility, ViewVisibility } from "./ViewVisibilityCalculator";
import { UnixTimeMS } from "polar-shared/src/metadata/ISODateTimeStrings";
import { Percentage100 } from "polar-shared/src/util/Percentages";
import { DurationMS } from "polar-shared/src/util/TimeDurations";
export declare type PageID = number;
export interface Position {
    readonly pageVisibility: PageVisibility;
    readonly origin: PageID;
    readonly created: UnixTimeMS;
    readonly updated: UnixTimeMS;
}
export declare type ComputeStrategy = 'init' | 'early' | 'jumped' | 'created' | 'updated' | 'no-pages';
export interface ComputeResult {
    readonly strategy: ComputeStrategy;
    readonly position: Position | undefined;
    readonly pagemarked: number | undefined;
}
export interface ExtendPagemark {
    readonly origin: PageID;
    readonly page: PageID;
    readonly perc: Percentage100;
}
export declare type CreatePagemarkCallback = (extendPagemark: ExtendPagemark) => void;
export declare type AutoPagemarkerMode = 'full' | 'partial';
export declare type Pixels = number;
export interface AutoPagemarkerOpts {
    readonly mode: AutoPagemarkerMode;
    readonly minDuration: DurationMS;
    readonly minPagemarkHeight: Pixels;
}
export declare class AutoPagemarker {
    private callback;
    private position?;
    private readonly opts;
    constructor(callback: CreatePagemarkCallback, opts?: Partial<AutoPagemarkerOpts>);
    compute(viewVisibility: ViewVisibility): ComputeResult;
}
