import { UnixTimeMS } from "polar-shared/src/metadata/ISODateTimeStrings";
import { Percentage1 } from "polar-shared/src/util/Percentages";
export interface Block {
    readonly top: number;
    readonly bottom: number;
}
export interface Viewport extends Block {
}
export interface Page extends Block {
    readonly id: number;
}
export interface PageVisibility extends Page {
    readonly perc: Percentage1;
}
export interface View {
    readonly viewport: Viewport;
    readonly pages: ReadonlyArray<Page>;
}
export interface ViewVisibility {
    readonly viewport: Viewport;
    readonly visibilities: ReadonlyArray<PageVisibility>;
    readonly computed: UnixTimeMS;
}
export declare class ViewVisibilityCalculator {
    static calculate(view: View): ViewVisibility;
    static visible(visibilities: ReadonlyArray<PageVisibility>): ReadonlyArray<PageVisibility>;
}
